# IceGrid::Query

## Overview

### [ "ami" ] interface Query

The IceGrid query interface. This interface is accessible to Ice clients who wish to lookup well-known objects.

## Operation Index

findObjectById
  Find a well-known object by identity.
findObjectByType
  Find a well-known object by type.
findObjectByTypeOnLeastLoadedNode
  Find a well-known object by type on the least loaded node.
findAllObjectsByType
  Find all the well-known objects with the given type.
findAllReplicas
  Find all the object replicas associated with the given proxy.

## Operations

### Object* findObjectById(::Ice::Identity id)

Find a well-known object by identity.

#### Parameters

id
  The identity.

#### Return Value

The proxy or null if no such object has been found.

### Object* findObjectByType(string type)

Find a well-known object by type. If there are several objects registered for the given type, the object will be randomly selected.

#### Parameters

type
  The object type.

#### Return Value

The proxy or null if no such object has been found.

### Object* findObjectByTypeOnLeastLoadedNode(string type, LoadSample sample)

Find a well-known object by type on the least loaded node. If the registry can't figure out the node that hosts the object (e.g., if the object was registered with a direct proxy), the registry assumes the object is hosted on a node that has a load average of 1.0.

#### Parameters

type
  The object type.

#### Return Value

The proxy or null if no such object has been found.

### ::Ice::ObjectProxySeq findAllObjectsByType(string type)

Find all the well-known objects with the given type.

#### Parameters

type
  The object type.

#### Return Value

The proxies or an empty sequence if no such objects have been found.

### ::Ice::ObjectProxySeq findAllReplicas(Object* proxy)

Find all the object replicas associated with the given proxy. If the given proxy is not an indirect proxy from a replica group, an empty sequence is returned.

#### Parameters

proxy
  The object proxy.

#### Return Value

The proxies of each object replica or an empty sequence if the given proxy is not from a replica group.